NMClient: libnm Reference Manual

## NMClient NMClient |

## Functions

GQuark | nm_client_error_quark ()
void | nm_dns_entry_unref ()
const char * | nm_dns_entry_get_interface ()
const char *const * | nm_dns_entry_get_nameservers ()
const char *const * | nm_dns_entry_get_domains ()
int | nm_dns_entry_get_priority ()
gboolean | nm_dns_entry_get_vpn ()
NMClient * | nm_client_new ()
void | nm_client_new_async ()
NMClient * | nm_client_new_finish ()
NMClientInstanceFlags | nm_client_get_instance_flags ()
GDBusConnection * | nm_client_get_dbus_connection ()
GMainContext * | nm_client_get_main_context ()
GObject * | nm_client_get_context_busy_watcher ()
const char * | nm_client_get_dbus_name_owner ()
const char * | nm_client_get_version ()
const guint32 * | nm_client_get_version_info ()
NMState | nm_client_get_state ()
gboolean | nm_client_get_startup ()
gboolean | nm_client_get_nm_running ()
NMObject * | nm_client_get_object_by_path ()
NMMetered | nm_client_get_metered ()
gboolean | nm_client_networking_get_enabled ()
const guint32 * | nm_client_get_capabilities ()
gboolean | nm_client_networking_set_enabled ()
gboolean | nm_client_wireless_get_enabled ()
void | nm_client_wireless_set_enabled ()
gboolean | nm_client_wireless_hardware_get_enabled ()
gboolean | nm_client_wwan_get_enabled ()
void | nm_client_wwan_set_enabled ()
gboolean | nm_client_wwan_hardware_get_enabled ()
gboolean | nm_client_wimax_get_enabled ()
void | nm_client_wimax_set_enabled ()
gboolean | nm_client_wimax_hardware_get_enabled ()
NMRadioFlags | nm_client_get_radio_flags ()
gboolean | nm_client_connectivity_check_get_available ()
gboolean | nm_client_connectivity_check_get_enabled ()
void | nm_client_connectivity_check_set_enabled ()
const char * | nm_client_connectivity_check_get_uri ()
gboolean | nm_client_get_logging ()
gboolean | nm_client_set_logging ()
NMClientPermissionResult | nm_client_get_permission_result ()
NMTernary | nm_client_get_permissions_state ()
NMConnectivityState | nm_client_get_connectivity ()
NMConnectivityState | nm_client_check_connectivity ()
void | nm_client_check_connectivity_async ()
NMConnectivityState | nm_client_check_connectivity_finish ()
gboolean | nm_client_save_hostname ()
void | nm_client_save_hostname_async ()
gboolean | nm_client_save_hostname_finish ()
const GPtrArray * | nm_client_get_devices ()
const GPtrArray * | nm_client_get_all_devices ()
NMDevice * | nm_client_get_device_by_path ()
NMDevice * | nm_client_get_device_by_iface ()
const GPtrArray * | nm_client_get_active_connections ()
NMActiveConnection * | nm_client_get_primary_connection ()
NMActiveConnection * | nm_client_get_activating_connection ()
void | nm_client_activate_connection_async ()
NMActiveConnection * | nm_client_activate_connection_finish ()
void | nm_client_add_and_activate_connection_async ()
NMActiveConnection * | nm_client_add_and_activate_connection_finish ()
void | nm_client_add_and_activate_connection2 ()
NMActiveConnection * | nm_client_add_and_activate_connection2_finish ()
gboolean | nm_client_deactivate_connection ()
void | nm_client_deactivate_connection_async ()
gboolean | nm_client_deactivate_connection_finish ()
const GPtrArray * | nm_client_get_connections ()
NMRemoteConnection * | nm_client_get_connection_by_id ()
NMRemoteConnection * | nm_client_get_connection_by_path ()
NMRemoteConnection * | nm_client_get_connection_by_uuid ()
void | nm_client_add_connection_async ()
NMRemoteConnection * | nm_client_add_connection_finish ()
void | nm_client_add_connection2 ()
NMRemoteConnection * | nm_client_add_connection2_finish ()
gboolean | nm_client_load_connections ()
void | nm_client_load_connections_async ()
gboolean | nm_client_load_connections_finish ()
gboolean | nm_client_reload_connections ()
void | nm_client_reload_connections_async ()
gboolean | nm_client_reload_connections_finish ()
const char * | nm_client_get_dns_mode ()
const char * | nm_client_get_dns_rc_manager ()
const GPtrArray * | nm_client_get_dns_configuration ()
const GPtrArray * | nm_client_get_checkpoints ()
void | nm_client_checkpoint_create ()
NMCheckpoint * | nm_client_checkpoint_create_finish ()
void | nm_client_checkpoint_destroy ()
gboolean | nm_client_checkpoint_destroy_finish ()
void | nm_client_checkpoint_rollback ()
GHashTable * | nm_client_checkpoint_rollback_finish ()
void | nm_client_checkpoint_adjust_rollback_timeout ()
gboolean | nm_client_checkpoint_adjust_rollback_timeout_finish ()
void | nm_client_reload ()
gboolean | nm_client_reload_finish ()
void | nm_client_dbus_call ()
GVariant * | nm_client_dbus_call_finish ()
void | nm_client_dbus_set_property ()
gboolean | nm_client_dbus_set_property_finish ()
void | nm_utils_print ()
gboolean | nm_utils_file_is_certificate ()
gboolean | nm_utils_file_is_private_key ()
gboolean | nm_utils_file_is_pkcs12 ()
void | nm_client_wait_shutdown ()
gboolean | nm_client_wait_shutdown_finish ()

## Properties

NMActiveConnection * | activating-connection | Read
GPtrArray * | active-connections | Read
GPtrArray * | all-devices | Read
gboolean | can-modify | Read
GArray * | capabilities | Read
GPtrArray * | checkpoints | Read
GPtrArray * | connections | Read
NMConnectivityState | connectivity | Read
gboolean | connectivity-check-available | Read
gboolean | connectivity-check-enabled | Read / Write
char * | connectivity-check-uri | Read
GDBusConnection * | dbus-connection | Read / Write / Construct Only
char * | dbus-name-owner | Read
GPtrArray * | devices | Read
GPtrArray * | dns-configuration | Read
char * | dns-mode | Read
char * | dns-rc-manager | Read
char * | hostname | Read
guint | instance-flags | Read / Write / Construct
guint | metered | Read
gboolean | networking-enabled | Read / Write
gboolean | nm-running | Read
NMTernary | permissions-state | Read
NMActiveConnection * | primary-connection | Read
guint | radio-flags | Read
gboolean | startup | Read
NMState | state | Read
char * | version | Read
GArray * | version-info | Read
gboolean | wimax-enabled | Read / Write
gboolean | wimax-hardware-enabled | Read
gboolean | wireless-enabled | Read / Write
gboolean | wireless-hardware-enabled | Read
gboolean | wwan-enabled | Read / Write
gboolean | wwan-hardware-enabled | Read

## Signals

void | active-connection-added | Run First
void | active-connection-removed | Run First
void | any-device-added | Run First
void | any-device-removed | Run First
void | connection-added | Run First
void | connection-removed | Run First
void | device-added | Run First
void | device-removed | Run First
void | permission-changed | Run First

## Types and Values

enum | NMClientInstanceFlags
#define | NM_CLIENT_VERSION
#define | NM_CLIENT_VERSION_INFO
#define | NM_CLIENT_STATE
#define | NM_CLIENT_STARTUP
#define | NM_CLIENT_NM_RUNNING
#define | NM_CLIENT_DBUS_CONNECTION
#define | NM_CLIENT_DBUS_NAME_OWNER
#define | NM_CLIENT_INSTANCE_FLAGS
#define | NM_CLIENT_NETWORKING_ENABLED
#define | NM_CLIENT_WIRELESS_ENABLED
#define | NM_CLIENT_WWAN_ENABLED
#define | NM_CLIENT_WIMAX_ENABLED
#define | NM_CLIENT_WIRELESS_HARDWARE_ENABLED
#define | NM_CLIENT_WWAN_HARDWARE_ENABLED
#define | NM_CLIENT_WIMAX_HARDWARE_ENABLED
#define | NM_CLIENT_RADIO_FLAGS
#define | NM_CLIENT_ACTIVE_CONNECTIONS
#define | NM_CLIENT_CONNECTIVITY
#define | NM_CLIENT_CONNECTIVITY_CHECK_URI
#define | NM_CLIENT_CONNECTIVITY_CHECK_AVAILABLE
#define | NM_CLIENT_CONNECTIVITY_CHECK_ENABLED
#define | NM_CLIENT_PRIMARY_CONNECTION
#define | NM_CLIENT_ACTIVATING_CONNECTION
#define | NM_CLIENT_DEVICES
#define | NM_CLIENT_ALL_DEVICES
#define | NM_CLIENT_CONNECTIONS
#define | NM_CLIENT_HOSTNAME
#define | NM_CLIENT_CAN_MODIFY
#define | NM_CLIENT_METERED
#define | NM_CLIENT_DNS_MODE
#define | NM_CLIENT_DNS_RC_MANAGER
#define | NM_CLIENT_DNS_CONFIGURATION
#define | NM_CLIENT_CHECKPOINTS
#define | NM_CLIENT_CAPABILITIES
#define | NM_CLIENT_PERMISSIONS_STATE
#define | NM_CLIENT_DEVICE_ADDED
#define | NM_CLIENT_DEVICE_REMOVED
#define | NM_CLIENT_ANY_DEVICE_ADDED
#define | NM_CLIENT_ANY_DEVICE_REMOVED
#define | NM_CLIENT_PERMISSION_CHANGED
#define | NM_CLIENT_CONNECTION_ADDED
#define | NM_CLIENT_CONNECTION_REMOVED
#define | NM_CLIENT_ACTIVE_CONNECTION_ADDED
#define | NM_CLIENT_ACTIVE_CONNECTION_REMOVED
enum | NMClientError
#define | NM_CLIENT_ERROR
| NMClient
| NMDnsEntry

## Object Hierarchy

        GBoxed
        ╰── NMDnsEntry
        GEnum
        ╰── NMClientError
        GFlags
        ╰── NMClientInstanceFlags
        GObject
        ╰── NMClient

## Implemented Interfaces

NMClient implements GInitable and GAsyncInitable.

## Description

## Functions

### nm_client_error_quark ()

    GQuark
    nm_client_error_quark (void);

### nm_dns_entry_unref ()

    void
    nm_dns_entry_unref (NMDnsEntry *entry);

### nm_dns_entry_get_interface ()

    const char *
    nm_dns_entry_get_interface (NMDnsEntry *entry);

### nm_dns_entry_get_nameservers ()

    const char *const *
    nm_dns_entry_get_nameservers (NMDnsEntry *entry);

### nm_dns_entry_get_domains ()

    const char *const *
    nm_dns_entry_get_domains (NMDnsEntry *entry);

### nm_dns_entry_get_priority ()

    int
    nm_dns_entry_get_priority (NMDnsEntry *entry);

### nm_dns_entry_get_vpn ()

    gboolean
    nm_dns_entry_get_vpn (NMDnsEntry *entry);

### nm_client_new ()

    NMClient *
    nm_client_new (GCancellable *cancellable,
                   GError **error);

### nm_client_new_async ()

    void
    nm_client_new_async (GCancellable *cancellable,
                         GAsyncReadyCallback callback,
                         gpointer user_data);

### nm_client_new_finish ()

    NMClient *
    nm_client_new_finish (GAsyncResult *result,
                          GError **error);

### nm_client_get_instance_flags ()

    NMClientInstanceFlags
    nm_client_get_instance_flags (NMClient *self);

### nm_client_get_dbus_connection ()

    GDBusConnection *
    nm_client_get_dbus_connection (NMClient *client);

### nm_client_get_main_context ()

    GMainContext *
    nm_client_get_main_context (NMClient *self);

### nm_client_get_context_busy_watcher ()

    GObject *
    nm_client_get_context_busy_watcher (NMClient *self);

### nm_client_get_dbus_name_owner ()

    const char *
    nm_client_get_dbus_name_owner (NMClient *client);

### nm_client_get_version ()

    const char *
    nm_client_get_version (NMClient *client);

### nm_client_get_version_info ()

    const guint32 *
    nm_client_get_version_info (NMClient *client,
                                gsize *length);

### nm_client_get_state ()

    NMState
    nm_client_get_state (NMClient *client);

### nm_client_get_startup ()

    gboolean
    nm_client_get_startup (NMClient *client);

### nm_client_get_nm_running ()

    gboolean
    nm_client_get_nm_running (NMClient *client);

### nm_client_get_object_by_path ()

    NMObject *
    nm_client_get_object_by_path (NMClient *client,
                                  const char *dbus_path);

### nm_client_get_metered ()

    NMMetered
    nm_client_get_metered (NMClient *client);

### nm_client_networking_get_enabled ()

    gboolean
    nm_client_networking_get_enabled (NMClient *client);

### nm_client_get_capabilities ()

    const guint32 *
    nm_client_get_capabilities (NMClient *client,
                                gsize *length);

### nm_client_networking_set_enabled ()

    gboolean
    nm_client_networking_set_enabled (NMClient *client,
                                      gboolean enabled,
                                      GError **error);

`nm_client_networking_set_enabled` is deprecated and should not be used in newly-written code.

### nm_client_wireless_get_enabled ()

    gboolean
    nm_client_wireless_get_enabled (NMClient *client);

### nm_client_wireless_set_enabled ()

    void
    nm_client_wireless_set_enabled (NMClient *client,
                                    gboolean enabled);

`nm_client_wireless_set_enabled` is deprecated and should not be used in newly-written code.

### nm_client_wireless_hardware_get_enabled ()

    gboolean
    nm_client_wireless_hardware_get_enabled
                                   (NMClient *client);

### nm_client_wwan_get_enabled ()

    gboolean
    nm_client_wwan_get_enabled (NMClient *client);

### nm_client_wwan_set_enabled ()

    void
    nm_client_wwan_set_enabled (NMClient *client,
                                gboolean enabled);

`nm_client_wwan_set_enabled` is deprecated and should not be used in newly-written code.

### nm_client_wwan_hardware_get_enabled ()

    gboolean
    nm_client_wwan_hardware_get_enabled (NMClient *client);

### nm_client_wimax_get_enabled ()

    gboolean
    nm_client_wimax_get_enabled (NMClient *client);

`nm_client_wimax_get_enabled` is deprecated and should not be used in newly-written code.

### nm_client_wimax_set_enabled ()

    void
    nm_client_wimax_set_enabled (NMClient *client,
                                 gboolean enabled);

`nm_client_wimax_set_enabled` is deprecated and should not be used in newly-written code.

### nm_client_wimax_hardware_get_enabled ()

    gboolean
    nm_client_wimax_hardware_get_enabled (NMClient *client);

`nm_client_wimax_hardware_get_enabled` is deprecated and should not be used in newly-written code.

### nm_client_get_radio_flags ()

    NMRadioFlags
    nm_client_get_radio_flags (NMClient *client);

### nm_client_connectivity_check_get_available ()

    gboolean
    nm_client_connectivity_check_get_available
                                   (NMClient *client);

### nm_client_connectivity_check_get_enabled ()

    gboolean
    nm_client_connectivity_check_get_enabled
                                   (NMClient *client);

### nm_client_connectivity_check_set_enabled ()

    void
    nm_client_connectivity_check_set_enabled
                                   (NMClient *client,
                                    gboolean enabled);

`nm_client_connectivity_check_set_enabled` is deprecated and should not be used in newly-written code.

### nm_client_connectivity_check_get_uri ()

    const char *
    nm_client_connectivity_check_get_uri (NMClient *client);

### nm_client_get_logging ()

    gboolean
    nm_client_get_logging (NMClient *client,
                           char **level,
                           char **domains,
                           GError **error);

`nm_client_get_logging` is deprecated and should not be used in newly-written code.

### nm_client_set_logging ()

    gboolean
    nm_client_set_logging (NMClient *client,
                           const char *level,
                           const char *domains,
                           GError **error);

`nm_client_set_logging` is deprecated and should not be used in newly-written code.

### nm_client_get_permission_result ()

    NMClientPermissionResult
    nm_client_get_permission_result (NMClient *client,
                                     NMClientPermission permission);

### nm_client_get_permissions_state ()

    NMTernary
    nm_client_get_permissions_state (NMClient *self);

### nm_client_get_connectivity ()

    NMConnectivityState
    nm_client_get_connectivity (NMClient *client);

### nm_client_check_connectivity ()

    NMConnectivityState
    nm_client_check_connectivity (NMClient *client,
                                  GCancellable *cancellable,
                                  GError **error);

`nm_client_check_connectivity` is deprecated and should not be used in newly-written code.

### nm_client_check_connectivity_async ()

    void
    nm_client_check_connectivity_async (NMClient *client,
                                        GCancellable *cancellable,
                                        GAsyncReadyCallback callback,
                                        gpointer user_data);

### nm_client_check_connectivity_finish ()

    NMConnectivityState
    nm_client_check_connectivity_finish (NMClient *client,
                                         GAsyncResult *result,
                                         GError **error);

### nm_client_save_hostname ()

    gboolean
    nm_client_save_hostname (NMClient *client,
                             const char *hostname,
                             GCancellable *cancellable,
                             GError **error);

`nm_client_save_hostname` is deprecated and should not be used in newly-written code.

### nm_client_save_hostname_async ()

    void
    nm_client_save_hostname_async (NMClient *client,
                                   const char *hostname,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

### nm_client_save_hostname_finish ()

    gboolean
    nm_client_save_hostname_finish (NMClient *client,
                                    GAsyncResult *result,
                                    GError **error);

### nm_client_get_devices ()

    const GPtrArray *
    nm_client_get_devices (NMClient *client);

### nm_client_get_all_devices ()

    const GPtrArray *
    nm_client_get_all_devices (NMClient *client);

### nm_client_get_device_by_path ()

    NMDevice *
    nm_client_get_device_by_path (NMClient *client,
                                  const char *object_path);

### nm_client_get_device_by_iface ()

    NMDevice *
    nm_client_get_device_by_iface (NMClient *client,
                                   const char *iface);

### nm_client_get_active_connections ()

    const GPtrArray *
    nm_client_get_active_connections (NMClient *client);

### nm_client_get_primary_connection ()

    NMActiveConnection *
    nm_client_get_primary_connection (NMClient *client);

### nm_client_get_activating_connection ()

    NMActiveConnection *
    nm_client_get_activating_connection (NMClient *client);

### nm_client_activate_connection_async ()

    void
    nm_client_activate_connection_async (NMClient *client,
                                         NMConnection *connection,
                                         NMDevice *device,
                                         const char *specific_object,
                                         GCancellable *cancellable,
                                         GAsyncReadyCallback callback,
                                         gpointer user_data);

### nm_client_activate_connection_finish ()

    NMActiveConnection *
    nm_client_activate_connection_finish (NMClient *client,
                                          GAsyncResult *result,
                                          GError **error);

### nm_client_add_and_activate_connection_async ()

    void
    nm_client_add_and_activate_connection_async
                                   (NMClient *client,
                                    NMConnection *partial,
                                    NMDevice *device,
                                    const char *specific_object,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

### nm_client_add_and_activate_connection_finish ()

    NMActiveConnection *
    nm_client_add_and_activate_connection_finish
                                   (NMClient *client,
                                    GAsyncResult *result,
                                    GError **error);

### nm_client_add_and_activate_connection2 ()

    void
    nm_client_add_and_activate_connection2
                                   (NMClient *client,
                                    NMConnection *partial,
                                    NMDevice *device,
                                    const char *specific_object,
                                    GVariant *options,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

### nm_client_add_and_activate_connection2_finish ()

    NMActiveConnection *
    nm_client_add_and_activate_connection2_finish
                                   (NMClient *client,
                                    GAsyncResult *result,
                                    GVariant **out_result,
                                    GError **error);

### nm_client_deactivate_connection ()

    gboolean
    nm_client_deactivate_connection (NMClient *client,
                                     NMActiveConnection *active,
                                     GCancellable *cancellable,
                                     GError **error);

`nm_client_deactivate_connection` is deprecated and should not be used in newly-written code.

### nm_client_deactivate_connection_async ()

    void
    nm_client_deactivate_connection_async (NMClient *client,
                                           NMActiveConnection *active,
                                           GCancellable *cancellable,
                                           GAsyncReadyCallback callback,
                                           gpointer user_data);

### nm_client_deactivate_connection_finish ()

    gboolean
    nm_client_deactivate_connection_finish
                                   (NMClient *client,
                                    GAsyncResult *result,
                                    GError **error);

### nm_client_get_connections ()

    const GPtrArray *
    nm_client_get_connections (NMClient *client);

### nm_client_get_connection_by_id ()

    NMRemoteConnection *
    nm_client_get_connection_by_id (NMClient *client,
                                    const char *id);

### nm_client_get_connection_by_path ()

    NMRemoteConnection *
    nm_client_get_connection_by_path (NMClient *client,
                                      const char *path);

### nm_client_get_connection_by_uuid ()

    NMRemoteConnection *
    nm_client_get_connection_by_uuid (NMClient *client,
                                      const char *uuid);

### nm_client_add_connection_async ()

    void
    nm_client_add_connection_async (NMClient *client,
                                    NMConnection *connection,
                                    gboolean save_to_disk,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

### nm_client_add_connection_finish ()

    NMRemoteConnection *
    nm_client_add_connection_finish (NMClient *client,
                                     GAsyncResult *result,
                                     GError **error);

### nm_client_add_connection2 ()

    void
    nm_client_add_connection2 (NMClient *client,
                               GVariant *settings,
                               NMSettingsAddConnection2Flags flags,
                               GVariant *args,
                               gboolean ignore_out_result,
                               GCancellable *cancellable,
                               GAsyncReadyCallback callback,
                               gpointer user_data);

### nm_client_add_connection2_finish ()

    NMRemoteConnection *
    nm_client_add_connection2_finish (NMClient *client,
                                      GAsyncResult *result,
                                      GVariant **out_result,
                                      GError **error);

### nm_client_load_connections ()

    gboolean
    nm_client_load_connections (NMClient *client,
                                char **filenames,
                                char ***failures,
                                GCancellable *cancellable,
                                GError **error);

`nm_client_load_connections` is deprecated and should not be used in newly-written code.

### nm_client_load_connections_async ()

    void
    nm_client_load_connections_async (NMClient *client,
                                      char **filenames,
                                      GCancellable *cancellable,
                                      GAsyncReadyCallback callback,
                                      gpointer user_data);

### nm_client_load_connections_finish ()

    gboolean
    nm_client_load_connections_finish (NMClient *client,
                                       char ***failures,
                                       GAsyncResult *result,
                                       GError **error);

### nm_client_reload_connections ()

    gboolean
    nm_client_reload_connections (NMClient *client,
                                  GCancellable *cancellable,
                                  GError **error);

`nm_client_reload_connections` is deprecated and should not be used in newly-written code.

### nm_client_reload_connections_async ()

    void
    nm_client_reload_connections_async (NMClient *client,
                                        GCancellable *cancellable,
                                        GAsyncReadyCallback callback,
                                        gpointer user_data);

### nm_client_reload_connections_finish ()

    gboolean
    nm_client_reload_connections_finish (NMClient *client,
                                         GAsyncResult *result,
                                         GError **error);

### nm_client_get_dns_mode ()

    const char *
    nm_client_get_dns_mode (NMClient *client);

### nm_client_get_dns_rc_manager ()

    const char *
    nm_client_get_dns_rc_manager (NMClient *client);

### nm_client_get_dns_configuration ()

    const GPtrArray *
    nm_client_get_dns_configuration (NMClient *client);

### nm_client_get_checkpoints ()

    const GPtrArray *
    nm_client_get_checkpoints (NMClient *client);

### nm_client_checkpoint_create ()

    void
    nm_client_checkpoint_create (NMClient *client,
                                 const GPtrArray *devices,
                                 guint32 rollback_timeout,
                                 NMCheckpointCreateFlags flags,
                                 GCancellable *cancellable,
                                 GAsyncReadyCallback callback,
                                 gpointer user_data);

### nm_client_checkpoint_create_finish ()

    NMCheckpoint *
    nm_client_checkpoint_create_finish (NMClient *client,
                                        GAsyncResult *result,
                                        GError **error);

### nm_client_checkpoint_destroy ()

    void
    nm_client_checkpoint_destroy (NMClient *client,
                                  const char *checkpoint_path,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

### nm_client_checkpoint_destroy_finish ()

    gboolean
    nm_client_checkpoint_destroy_finish (NMClient *client,
                                         GAsyncResult *result,
                                         GError **error);

### nm_client_checkpoint_rollback ()

    void
    nm_client_checkpoint_rollback (NMClient *client,
                                   const char *checkpoint_path,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

### nm_client_checkpoint_rollback_finish ()

    GHashTable *
    nm_client_checkpoint_rollback_finish (NMClient *client,
                                          GAsyncResult *result,
                                          GError **error);

### nm_client_checkpoint_adjust_rollback_timeout ()

    void
    nm_client_checkpoint_adjust_rollback_timeout
                                   (NMClient *client,
                                    const char *checkpoint_path,
                                    guint32 add_timeout,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

### nm_client_checkpoint_adjust_rollback_timeout_finish ()

    gboolean
    nm_client_checkpoint_adjust_rollback_timeout_finish
                                   (NMClient *client,
                                    GAsyncResult *result,
                                    GError **error);

### nm_client_reload ()

    void
    nm_client_reload (NMClient *client,
                      NMManagerReloadFlags flags,
                      GCancellable *cancellable,
                      GAsyncReadyCallback callback,
                      gpointer user_data);

### nm_client_reload_finish ()

    gboolean
    nm_client_reload_finish (NMClient *client,
                             GAsyncResult *result,
                             GError **error);

### nm_client_dbus_call ()

    void
    nm_client_dbus_call (NMClient *client,
                         const char *object_path,
                         const char *interface_name,
                         const char *method_name,
                         GVariant *parameters,
                         const GVariantType *reply_type,
                         int timeout_msec,
                         GCancellable *cancellable,
                         GAsyncReadyCallback callback,
                         gpointer user_data);

### nm_client_dbus_call_finish ()

    GVariant *
    nm_client_dbus_call_finish (NMClient *client,
                                GAsyncResult *result,
                                GError **error);

### nm_client_dbus_set_property ()

    void
    nm_client_dbus_set_property (NMClient *client,
                                 const char *object_path,
                                 const char *interface_name,
                                 const char *property_name,
                                 GVariant *value,
                                 int timeout_msec,
                                 GCancellable *cancellable,
                                 GAsyncReadyCallback callback,
                                 gpointer user_data);

### nm_client_dbus_set_property_finish ()

    gboolean
    nm_client_dbus_set_property_finish (NMClient *client,
                                        GAsyncResult *result,
                                        GError **error);

### nm_utils_print ()

    void
    nm_utils_print (int output_mode,
                    const char *msg);

### nm_utils_file_is_certificate ()

    gboolean
    nm_utils_file_is_certificate (const char *filename);

### nm_utils_file_is_private_key ()

    gboolean
    nm_utils_file_is_private_key (const char *filename,
                                  gboolean *out_encrypted);

### nm_utils_file_is_pkcs12 ()

    gboolean
    nm_utils_file_is_pkcs12 (const char *filename);

### nm_client_wait_shutdown ()

    void
    nm_client_wait_shutdown (NMClient *client,
                             gboolean integrate_maincontext,
                             GCancellable *cancellable,
                             GAsyncReadyCallback callback,
                             gpointer user_data);

### nm_client_wait_shutdown_finish ()

    gboolean
    nm_client_wait_shutdown_finish (GAsyncResult *result,
                                    GError **error);

## Types and Values

### enum NMClientInstanceFlags

#### Members

NM_CLIENT_INSTANCE_FLAGS_NONE | special value to indicate no flags. |
NM_CLIENT_INSTANCE_FLAGS_NO_AUTO_FETCH_PERMISSIONS | by default, NMClient will fetch the permissions via "GetPermissions" and refetch them when "CheckPermissions" signal gets received. By setting this flag, this behavior can be disabled. You can toggle this flag to enable and disable automatic fetching of the permissions. Watch also `nm_client_get_permissions_state()` to know whether the permissions are up to date. |
NM_CLIENT_INSTANCE_FLAGS_INITIALIZED_GOOD | as NMClient is an GInitable and GAsyncInitable, `nm_client_get_instance_flags()` returns this flag once initialization completed with success. This flag cannot be set as NM_CLIENT_INSTANCE_FLAGS property. Since: 1.42. |
NM_CLIENT_INSTANCE_FLAGS_INITIALIZED_BAD | like `NM_CLIENT_INSTANCE_FLAGS_INITIALIZED_GOOD` indicates that the instance completed initialization with failure. In that case the instance is unusable. Since: 1.42. |

Since: 1.24

### NM_CLIENT_VERSION

    #define NM_CLIENT_VERSION         "version"

### NM_CLIENT_VERSION_INFO

    #define NM_CLIENT_VERSION_INFO    "version-info"

### NM_CLIENT_STATE

    #define NM_CLIENT_STATE           "state"

### NM_CLIENT_STARTUP

    #define NM_CLIENT_STARTUP         "startup"

### NM_CLIENT_NM_RUNNING

    #define NM_CLIENT_NM_RUNNING      "nm-running"

### NM_CLIENT_DBUS_CONNECTION

    #define NM_CLIENT_DBUS_CONNECTION "dbus-connection"

### NM_CLIENT_DBUS_NAME_OWNER

    #define NM_CLIENT_DBUS_NAME_OWNER "dbus-name-owner"

### NM_CLIENT_INSTANCE_FLAGS

    #define NM_CLIENT_INSTANCE_FLAGS  "instance-flags"

### NM_CLIENT_NETWORKING_ENABLED

    #define NM_CLIENT_NETWORKING_ENABLED "networking-enabled"

`NM_CLIENT_NETWORKING_ENABLED` is deprecated and should not be used in newly-written code.

### NM_CLIENT_WIRELESS_ENABLED

    #define NM_CLIENT_WIRELESS_ENABLED "wireless-enabled"

`NM_CLIENT_WIRELESS_ENABLED` is deprecated and should not be used in newly-written code.

### NM_CLIENT_WWAN_ENABLED

    #define NM_CLIENT_WWAN_ENABLED "wwan-enabled"

`NM_CLIENT_WWAN_ENABLED` is deprecated and should not be used in newly-written code.

### NM_CLIENT_WIMAX_ENABLED

    #define NM_CLIENT_WIMAX_ENABLED "wimax-enabled"

`NM_CLIENT_WIMAX_ENABLED` is deprecated and should not be used in newly-written code.

### NM_CLIENT_WIRELESS_HARDWARE_ENABLED

    #define NM_CLIENT_WIRELESS_HARDWARE_ENABLED "wireless-hardware-enabled"

### NM_CLIENT_WWAN_HARDWARE_ENABLED

    #define NM_CLIENT_WWAN_HARDWARE_ENABLED     "wwan-hardware-enabled"

### NM_CLIENT_WIMAX_HARDWARE_ENABLED

    #define NM_CLIENT_WIMAX_HARDWARE_ENABLED    "wimax-hardware-enabled"

### NM_CLIENT_RADIO_FLAGS

    #define NM_CLIENT_RADIO_FLAGS "radio-flags"

### NM_CLIENT_ACTIVE_CONNECTIONS

    #define NM_CLIENT_ACTIVE_CONNECTIONS           "active-connections"

### NM_CLIENT_CONNECTIVITY

    #define NM_CLIENT_CONNECTIVITY                 "connectivity"

### NM_CLIENT_CONNECTIVITY_CHECK_URI

    #define NM_CLIENT_CONNECTIVITY_CHECK_URI       "connectivity-check-uri"

### NM_CLIENT_CONNECTIVITY_CHECK_AVAILABLE

    #define NM_CLIENT_CONNECTIVITY_CHECK_AVAILABLE "connectivity-check-available"

### NM_CLIENT_CONNECTIVITY_CHECK_ENABLED

    #define NM_CLIENT_CONNECTIVITY_CHECK_ENABLED "connectivity-check-enabled"

`NM_CLIENT_CONNECTIVITY_CHECK_ENABLED` is deprecated and should not be used in newly-written code.

### NM_CLIENT_PRIMARY_CONNECTION

    #define NM_CLIENT_PRIMARY_CONNECTION    "primary-connection"

### NM_CLIENT_ACTIVATING_CONNECTION

    #define NM_CLIENT_ACTIVATING_CONNECTION "activating-connection"

### NM_CLIENT_DEVICES

    #define NM_CLIENT_DEVICES               "devices"

### NM_CLIENT_ALL_DEVICES

    #define NM_CLIENT_ALL_DEVICES           "all-devices"

### NM_CLIENT_CONNECTIONS

    #define NM_CLIENT_CONNECTIONS           "connections"

### NM_CLIENT_HOSTNAME

    #define NM_CLIENT_HOSTNAME              "hostname"

### NM_CLIENT_CAN_MODIFY

    #define NM_CLIENT_CAN_MODIFY            "can-modify"

### NM_CLIENT_METERED

    #define NM_CLIENT_METERED               "metered"

### NM_CLIENT_DNS_MODE

    #define NM_CLIENT_DNS_MODE              "dns-mode"

### NM_CLIENT_DNS_RC_MANAGER

    #define NM_CLIENT_DNS_RC_MANAGER        "dns-rc-manager"

### NM_CLIENT_DNS_CONFIGURATION

    #define NM_CLIENT_DNS_CONFIGURATION     "dns-configuration"

### NM_CLIENT_CHECKPOINTS

    #define NM_CLIENT_CHECKPOINTS           "checkpoints"

### NM_CLIENT_CAPABILITIES

    #define NM_CLIENT_CAPABILITIES          "capabilities"

### NM_CLIENT_PERMISSIONS_STATE

    #define NM_CLIENT_PERMISSIONS_STATE     "permissions-state"

### NM_CLIENT_DEVICE_ADDED

    #define NM_CLIENT_DEVICE_ADDED              "device-added"

### NM_CLIENT_DEVICE_REMOVED

    #define NM_CLIENT_DEVICE_REMOVED            "device-removed"

### NM_CLIENT_ANY_DEVICE_ADDED

    #define NM_CLIENT_ANY_DEVICE_ADDED          "any-device-added"

### NM_CLIENT_ANY_DEVICE_REMOVED

    #define NM_CLIENT_ANY_DEVICE_REMOVED        "any-device-removed"

### NM_CLIENT_PERMISSION_CHANGED

    #define NM_CLIENT_PERMISSION_CHANGED        "permission-changed"

### NM_CLIENT_CONNECTION_ADDED

    #define NM_CLIENT_CONNECTION_ADDED          "connection-added"

### NM_CLIENT_CONNECTION_REMOVED

    #define NM_CLIENT_CONNECTION_REMOVED        "connection-removed"

### NM_CLIENT_ACTIVE_CONNECTION_ADDED

    #define NM_CLIENT_ACTIVE_CONNECTION_ADDED   "active-connection-added"

### NM_CLIENT_ACTIVE_CONNECTION_REMOVED

    #define NM_CLIENT_ACTIVE_CONNECTION_REMOVED "active-connection-removed"

### enum NMClientError

Describes errors that may result from operations involving a NMClient.

D-Bus operations may also return errors from other domains, including NMManagerError, NMSettingsError, NMAgentManagerError, and NMConnectionError.

#### Members

NM_CLIENT_ERROR_FAILED | unknown or unclassified error |
NM_CLIENT_ERROR_MANAGER_NOT_RUNNING | an operation that requires NetworkManager failed because NetworkManager is not running |
NM_CLIENT_ERROR_OBJECT_CREATION_FAILED | NetworkManager claimed that an operation succeeded, but the object that was allegedly created (eg, NMRemoteConnection, NMActiveConnection) was apparently destroyed before NMClient could create a representation of it. |

### NM_CLIENT_ERROR

    #define NM_CLIENT_ERROR nm_client_error_quark()

### NMClient

    typedef struct _NMClient NMClient;

NMClient contains a cache of the objects of NetworkManager's D-Bus API. It uses GMainContext and GDBusConnection for that and registers to D-Bus signals. That means, when iterating the associated GMainContext, D-Bus signals gets processed and the NMClient instance updates and emits GObject signals.

### NMDnsEntry

    typedef struct _NMDnsEntry NMDnsEntry;

Since: 1.6

## Property Details

### The `“activating-connection”` property

      “activating-connection”    NMActiveConnection *

Owner: NMClient

Flags: Read

### The `“active-connections”` property

      “active-connections”       GPtrArray *

Owner: NMClient

Flags: Read

### The `“all-devices”` property

      “all-devices”              GPtrArray *

Owner: NMClient

Flags: Read

### The `“can-modify”` property

      “can-modify”               gboolean

Owner: NMClient

Flags: Read

Default value: FALSE

### The `“capabilities”` property

      “capabilities”             GArray *

Owner: NMClient

Flags: Read

### The `“checkpoints”` property

      “checkpoints”              GPtrArray *

Owner: NMClient

Flags: Read

### The `“connections”` property

      “connections”              GPtrArray *

Owner: NMClient

Flags: Read

### The `“connectivity”` property

      “connectivity”             NMConnectivityState

Owner: NMClient

Flags: Read

Default value: NM_CONNECTIVITY_UNKNOWN

### The `“connectivity-check-available”` property

      “connectivity-check-available” gboolean

Owner: NMClient

Flags: Read

Default value: FALSE

### The `“connectivity-check-enabled”` property

      “connectivity-check-enabled” gboolean

Owner: NMClient

Flags: Read / Write

Default value: FALSE

### The `“connectivity-check-uri”` property

      “connectivity-check-uri”   char *

Owner: NMClient

Flags: Read

Default value: NULL

### The `“dbus-connection”` property

      “dbus-connection”          GDBusConnection *

Owner: NMClient

Flags: Read / Write / Construct Only

### The `“dbus-name-owner”` property

      “dbus-name-owner”          char *

Owner: NMClient

Flags: Read

Default value: NULL

### The `“devices”` property

      “devices”                  GPtrArray *

Owner: NMClient

Flags: Read

### The `“dns-configuration”` property

      “dns-configuration”        GPtrArray *

Owner: NMClient

Flags: Read

### The `“dns-mode”` property

      “dns-mode”                 char *

Owner: NMClient

Flags: Read

Default value: NULL

### The `“dns-rc-manager”` property

      “dns-rc-manager”           char *

Owner: NMClient

Flags: Read

Default value: NULL

### The `“hostname”` property

      “hostname”                 char *

Owner: NMClient

Flags: Read

Default value: NULL

### The `“instance-flags”` property

      “instance-flags”           guint

Owner: NMClient

Flags: Read / Write / Construct

Default value: 0

### The `“metered”` property

      “metered”                  guint

Owner: NMClient

Flags: Read

Default value: 0

### The `“networking-enabled”` property

      “networking-enabled”       gboolean

Owner: NMClient

Flags: Read / Write

Default value: FALSE

### The `“nm-running”` property

      “nm-running”               gboolean

Owner: NMClient

Flags: Read

Default value: FALSE

### The `“permissions-state”` property

      “permissions-state”        NMTernary

Owner: NMClient

Flags: Read

Default value: NM_TERNARY_DEFAULT

### The `“primary-connection”` property

      “primary-connection”       NMActiveConnection *

Owner: NMClient

Flags: Read

### The `“radio-flags”` property

      “radio-flags”              guint

Owner: NMClient

Flags: Read

Default value: 0

### The `“startup”` property

      “startup”                  gboolean

Owner: NMClient

Flags: Read

Default value: FALSE

### The `“state”` property

      “state”                    NMState

Owner: NMClient

Flags: Read

Default value: NM_STATE_UNKNOWN

### The `“version”` property

      “version”                  char *

Owner: NMClient

Flags: Read

Default value: NULL

### The `“version-info”` property

      “version-info”             GArray *

Owner: NMClient

Flags: Read

### The `“wimax-enabled”` property

      “wimax-enabled”            gboolean

Owner: NMClient

Flags: Read / Write

Default value: FALSE

### The `“wimax-hardware-enabled”` property

      “wimax-hardware-enabled”   gboolean

Owner: NMClient

Flags: Read

Default value: FALSE

### The `“wireless-enabled”` property

      “wireless-enabled”         gboolean

Owner: NMClient

Flags: Read / Write

Default value: FALSE

### The `“wireless-hardware-enabled”` property

      “wireless-hardware-enabled” gboolean

Owner: NMClient

Flags: Read

Default value: FALSE

### The `“wwan-enabled”` property

      “wwan-enabled”             gboolean

Owner: NMClient

Flags: Read / Write

Default value: FALSE

### The `“wwan-hardware-enabled”` property

      “wwan-hardware-enabled”    gboolean

Owner: NMClient

Flags: Read

Default value: FALSE

## Signal Details

### The `“active-connection-added”` signal

    void
    user_function (NMClient           *nmclient,
                   NMActiveConnection *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“active-connection-removed”` signal

    void
    user_function (NMClient           *nmclient,
                   NMActiveConnection *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“any-device-added”` signal

    void
    user_function (NMClient *nmclient,
                   GObject  *arg1,
                   gpointer  user_data)

Flags: Run First

### The `“any-device-removed”` signal

    void
    user_function (NMClient *nmclient,
                   GObject  *arg1,
                   gpointer  user_data)

Flags: Run First

### The `“connection-added”` signal

    void
    user_function (NMClient           *nmclient,
                   NMRemoteConnection *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“connection-removed”` signal

    void
    user_function (NMClient           *nmclient,
                   NMRemoteConnection *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“device-added”` signal

    void
    user_function (NMClient *nmclient,
                   GObject  *arg1,
                   gpointer  user_data)

Flags: Run First

### The `“device-removed”` signal

    void
    user_function (NMClient *nmclient,
                   GObject  *arg1,
                   gpointer  user_data)

Flags: Run First

### The `“permission-changed”` signal

    void
    user_function (NMClient *nmclient,
                   guint     arg1,
                   guint     arg2,
                   gpointer  user_data)

Flags: Run First